#!/usr/bin/env python3
from countpaths import *

if __name__ == "__main__":
    from results import Results
    r = Results("graph_sizes.db")
    for topo, (files, samp) in graphnames.items():
        for i in range(1,samp+1):
            for name in files:
                if i != 1:
                    n = name[:-1] + str(i)
                else:
                    n = name
                print(n)
                g = read_graph(n)
                p = round(g.radix / designd[topo] * g.vertices / g.edge)
                collect = r.collector(tag="measured", count=Results.Int, topo=topo, n=g.vertices, radix=g.radix, sample=i, concentration=p, edge=g.edge, k=g.radix+p)
                collect(count=0) # one dummy sample
                r.commit()

    # compute all DF sizes
    for a in range(2, 40, 2):
        ng = a * a * 0.5 + 1
        p = a * 0.5
        nr = ng * a
        radix = a-1+a*0.5
        collect = r.collector(tag="computed", count=Results.Int, topo="DF", n=nr, radix=radix, concentration=p, edge=nr, k=radix+p)
        collect(count=0) # one dummy sample
    r.commit()

    # compute all HX sizes
    for L in [2,3,4]:
        for S in range(2, 40):
            nr = S ** L
            radix = (S-1) * L
            p = int(radix / L)
            collect = r.collector(tag="computed", count=Results.Int, topo="HX%d" % L, n=nr, radix=radix, concentration=p, edge=nr, k = radix+p)
            collect(count=0) # one dummy sample
    r.commit()

    # compute all FT sizes
    for k in range(4, 80, 2):
        group = k**2/4
        edge = 2*group
        p = k/2
        nr = 5*group
        radix = (3*k + 2*k/2.0)/5.0 # radix shall not include endpoint links
        collect = r.collector(tag="computed", count=Results.Int, topo="FT", n=nr, radix=radix, concentration=p, edge=edge, k=k)
        collect(count=0) # one dummy sample
    r.commit()
    r.close()
