from countpaths import *
from interference_deterministic import *

g = read_graph("../network-examples/adj-format/DF.8.adj.txt")
h = prepare_graph(g)

def c_AB(a,b, limit, p):
    g = h.tocsr(copy=True)
    res = np.zeros((limit+1, 2**limit), dtype=np.int32)
    groupsize = 2*p
    while True:
        p = bfs([a],[b], limit, g)
        if not p: break
        sig1 = sum([2**i * (1 if s//groupsize == t//groupsize else 0) for i, (s,t) in enumerate(p)]) 
        sig2 = sum([2**(len(p)-1-i) * (1 if s//groupsize == t//groupsize else 0) for i, (s,t) in enumerate(p)]) 
        sig = sig1 if sig1 > sig2 else sig2
        #print((format(sig, '0%db'%len(p)).replace("1", "l").replace("0", "g"), sig1, sig2))
        res[len(p), sig] += 1
        for s,t in p:
            g[s,t] = 0
            g[t,s] = 0
    return res

r = list(range(0, g.edge))
pairs = [random.sample(r, 2) for _ in range(0, 10000)]
limit = 3
p = 8

def doall(ab):
    a,b = ab
    return c_AB(a, b, limit, p)

out = pmap(doall, pairs)

r = Results('df-paths.db')
collectc = r.collector(a=Results.Int, b=Results.Int,
                    c_ab=Results.Int, len=Results.Int, sig = Results.Text,
                    topo="DF", n_r=g.vertices, radix=g.radix)

for (a,b), c_ab in zip(pairs, out):
    for i in range(c_ab.shape[0]):
        for sig in range(c_ab.shape[1]):
            if c_ab[i, sig] > 0:
                lbl = format(sig, '0%db'%i).replace("1", "l").replace("0", "g")
                collectc(len=i, a=a, b=b, c_ab=c_ab[i, sig], sig=lbl)
r.commit()


