def make_complete(n, part):
    q = int(n/part)
    assert n == q*part
    graph = [[] for _ in range(n)]
    
    for i in range(0, part):
        for j in range(0, part):
            if i==j: continue
            for k in range(0, q):
                for l in range(0, q):
                    graph[i*q+k].append(j*q+l)
    return graph
    
def output_graph(graph, file=None):
    print(len(graph), int(sum(len(n) for n in graph) / 2), file=file)
    for node in graph:
       print( " ".join(str(e+1) for e in node) + " ", file=file)
        
if __name__ == '__main__':
    networks = [(11, 11, "Complete.10.adj.txt"),
                (32, 32, "Complete.32.adj.txt"),
                (101, 101, "Complete.100.adj.txt"),
                (20, 2, "Bipartite.10.adj.txt"),
                (200, 2, "Bipartite.100.adj.txt"),
                (15, 3, "Tripartite.10.adj.txt"),
                (150, 3, "Tripartite.100.adj.txt")]
    for n in networks:
        print(n)
        with open(n[2], "w") as f:
            g = make_complete(n[0], n[1])
            output_graph(g, file=f)
    
