def make_dragonfly(p):
    n = 4*p**3 + 2*p
    a = 2*p
    h = p
    g = a*h + 1
    assert(n == a*g)

    graph = [[] for _ in range(n)]
    
    for i in range(0, g):
        for j in range(0, a):
            v = i*a+j
            local = [i*a+x for x in range(0,a) if x != j]
            graph[v] += local
    gnode = [a*x for x in range(0,g)]
    gcount = [0] * g
    for i in range(0, g):
        for j in range(i+1, g):
            v1 = gnode[i]
            v2 = gnode[j]
            gcount[i] += 1
            gcount[j] += 1
            if gcount[i] >= h:
                gcount[i] = 0
                gnode[i] += 1
            if gcount[j] >= h:
                gcount[j] = 0
                gnode[j] += 1
            graph[v1].append(v2)
            graph[v2].append(v1)
    assert(all([len(v) == (3*p-1) for v in graph]))
    return graph
    
def output_graph(graph, file=None):
    print(len(graph), int(sum(len(n) for n in graph) / 2), file=file)
    for node in graph:
       print( " ".join(str(e+1) for e in node) + " ", file=file)
        
if __name__ == '__main__':
    networks = [
                (2, "DF.2.adj.txt"),
                (4, "DF.4.adj.txt"),
                (8, "DF.8.adj.txt"),
                (12, "DF.12.adj.txt"),
    ]
    for n in networks:
        print(n)
        with open(n[1], "w") as f:
            g = make_dragonfly(n[0])
            output_graph(g, file=f)
    
