def make_hyperx(l, s):
    n = s ** l
    graph = [[] for _ in range(n)]
    
    for i in range(0, n):
        for j in range(0, n):
            if i==j: continue
            if (l-1) == sum(int(i/s**k) % s == int(j/s**k) % s for k in range(0,l)):
                graph[i].append(j)
    return graph
    
def output_graph(graph, file=None):
    print(len(graph), int(sum(len(n) for n in graph) / 2), file=file)
    for node in graph:
       print( " ".join(str(e+1) for e in node) + " ", file=file)
        
if __name__ == '__main__':
    networks = [(3, 6, "HyperX3.15.adj.txt"),
                (3, 11, "HyperX3.30.adj.txt"),
                (2, 12, "HyperX2.22.adj.txt"),
                (2, 22, "HyperX2.42.adj.txt"),

                (2, 4, "HyperX2.6.adj.txt"),
                (3, 3, "HyperX3.6.adj.txt"),
    ]
    for n in networks:
        print(n)
        with open(n[2], "w") as f:
            g = make_hyperx(n[0], n[1])
            output_graph(g, file=f)
    
