import random

def make_jellyfish(k, r, n):
    graph = [[] for _ in range(n)]
    
    free = [node for node in enumerate(graph)]
    while True:
        #free = [node for node in enumerate(graph) if len(node[1]) < r]
        if len(free) >= 2:
            pair = random.sample(free, 2)
            pair[0][1].append(pair[1][0])
            pair[1][1].append(pair[0][0])
            if len(pair[0][1]) >= r:
                free.remove(pair[0])
            if len(pair[1][1]) >= r:
                free.remove(pair[1])
        else:
            # eliminate multiedges. not 100% sure this will always terminate...
            graph = [list(set(node)) for node in graph]
            free = [node for node in enumerate(graph) if len(node[1]) < r]
            if len(free) <= 2:
                break
    if any(len(node) != r for node in graph): # retry if non-regular.
        return make_jellyfish(k, r, n)
    return graph
        
    
def output_graph(graph, file=None):
    print(len(graph), int(sum(len(n) for n in graph) / 2), file=file)
    for node in graph:
       print( " ".join(str(e+1) for e in node) + " ", file=file)
        
if __name__ == '__main__':
    networks = [
                #(242, 17, "JF-MMS.17.adj.txt"),
                #(722, 29, "JF-MMS.29.adj.txt"),
                #(2738, 55, "JF-MMS.55.adj.txt"),
                (242, 17, "JF-MMS.17.adj.txt"),
                (1058, 35, "JF-MMS.35.adj.txt"),
                (5618, 79, "JF-MMS.79.adj.txt"),

                #(264, 11, "JF-DF.4.adj.txt"),
                #(2064, 23, "JF-DF.8.adj.txt"),
                #(6936, 35, "JF-DF.12.adj.txt"),
                
                #(144, 22, "JF-HX2.22.adj.txt"),
                #(484, 42, "JF-HX2.42.adj.txt"),
                #(216, 15, "JF-HX3.15.adj.txt"),
                #(1331, 30, "JF-HX3.30.adj.txt"),
                #(4913, 48, "JF-HX3.48.adj.txt"),
                
                #(405, 14, "JF-FT.9.adj.txt"), 
                #(1620, 29, "JF-FT.18.adj.txt"),
                #(6480, 58, "JF-FT.36.adj.txt"),
                #(320, 13, "JF-FT.8.adj.txt"),
                #(1280, 25, "JF-FT.16.adj.txt"),
                #(3380, 41, "JF-FT.26.adj.txt"),

                #(17*8, 16, "JF-XP.16.adj.txt"),
                #(33*32, 32, "JF-XP.32.adj.txt"),

                #(18, 5, "JF.5.adj.txt"),
                ]

    nsamp = 3
    random.seed(42)
    
    for n in networks:
        print(n)
        for i in range(1, nsamp+1):
            with open("%s.%i" % (n[2], i), "w") as f:
                g = make_jellyfish(0, n[1], n[0])
                output_graph(g, file=f)
    
