import numpy as np
from math import sqrt, inf, nan
from itertools import combinations
import random

import mmm_ops

from countpaths import *
from results import Results

def count_shortest_paths(graph, limit, collect):
    
    g = graph
    
    count = 100000
    r = list(range(0, g.edge))
    if False: #g.edge ** 2 < count: 
        pairs = list(combinations(r, 2))
    else:
        pairs = [random.sample(r, 2) for _ in range(0, count)]
    
    diag = np.arange(graph.vertices)
    acc = np.identity(graph.vertices, dtype=edgetype)
    connected = np.zeros_like(graph, dtype=np.bool)

    for i in range(1, limit+1):
        step = acc.dot(graph)
            
        shortest = np.multiply(step, ~connected) # elem-wise mask
        connected += (step != 0)
        
        for s,t in pairs:
            if shortest[s,t]:
                collect(len=i, multiplicity=step[s,t])

        acc = step
        
if __name__ == '__main__':
    r = Results('xpander.db')

    for topo, (files, samp) in graphnames.items():
        for i in range(1,samp+1):
            for name in files:
                if i != 1:
                    n = name[:-1] + str(i)
                else:
                    n = name
                print(n)
                g = read_graph(n)
                g.topo = topo
                g.sample = i
                p = round(g.radix / designd[topo] * g.vertices / g.edge)
                collect  = r.collector(tag="shortest-path", len=Results.Int, multiplicity=Results.Int, topo=g.topo, n_r=g.vertices, radix=g.radix, n_e=g.edge*p, p=p, designd=designd[topo], sample=g.sample)
                count_shortest_paths(g, 5, collect)
                r.commit()
    r.close()
