from countpaths import read_graph, graphnames
from results import Results
import numpy as np
import vertex_disjoint_paths

def sparsify(g, amount):
    total = int(g.sum())
    remaining = int(total*amount)
    values = np.array([1]*remaining + [0]*(total-remaining))
    g[g > 0] = values
    

if __name__ == '__main__':
    r = Results('layers.db')
    for topo, (files, samp) in graphnames.items():
        for i in range(1,samp+1):
            for name in files:
                if i != 1:
                    n = name[:-1] + str(i)
                else:
                    n = name
                print(n)
                
                for amount in [0.5, 0.66, 1]:
                    g = read_graph(n)
                    sparsify(g, amount)
                    collect = r.collector(s=Results.Int, t=Results.Int, len=Results.Int, count=Results.Int, topo=topo, n=g.vertices, radix=g.radix, sample=i, fraction=amount)
                    vertex_disjoint_paths.countpaths(g, 5, collect)
                    r.commit()
    r.close()
