#!/usr/bin/env python3
from itertools import product
from copy import deepcopy

layered = {
    'net': [
        #'baseline 9 162',
        #'Star_0.txt 1500 1',
        #'Star_0.txt 15000 1',

        #'../analysis-paths/Complete.32.adj.txt 32 32', # 1024 hosts
        #'../analysis-paths/Complete.100.adj.txt 100 101', # 10100 hosts

        #'../network-examples/adj-format/MMS.17.adj.txt 8 242', # 1936 hosts
        '../network-examples/adj-format/MMS.29.adj.txt 14 722', # 10108 hosts
        #'../network-examples/adj-format/MMS.55.adj.txt 28 2738', # 76664 hosts
        #'../analysis-paths/JF-MMS.17.adj.txt.1 8 242', # 1936 hosts
        '../analysis-paths/JF-MMS.29.adj.txt.1 14 722', # 10108 hosts
        #'../analysis-paths/JF-MMS.55.adj.txt.1 28 2738', # 76664 hosts
        
        #'../analysis-paths/HyperX2.22.adj.txt 11 144', # 1584 hosts
        #'../analysis-paths/HyperX2.42.adj.txt 21 484', # 10164 hosts
        #'../analysis-paths/JF-HX2.22.adj.txt.1 11 144', # 1584 hosts
        #'../analysis-paths/JF-HX2.42.adj.txt.1 21 484', # 10164 hosts

        #'../analysis-paths/Xp.16.adj.txt.1 8 136', # 1088 hosts
        #'../analysis-paths/Xp.32.adj.txt.1 16 1056', # 16896 hosts
        #'../analysis-paths/JF-XP.16.adj.txt.1 8 136', # 1088 hosts
        #'../analysis-paths/JF-XP.32.adj.txt.1 16 1056', # 16896 hosts
    ],
    'overcommit': [1.0],
    'alg' : ["hyb"],
    'workload': ["ring", "permutation"],
    'mapping': ["blocked"],
    'n_layers': [10],
    'rho': [1, 10, 100],
    "lambda": [300],
    "queuesize": [8],
    "cwnd": [8],
    "strategy": ["FLOWLET"],
    "pullrate": [1],
    "skew": [0.1, 0.5, 0.9],
    "variant": ["hyb"]
}

dia3 = deepcopy(layered)
dia3['net'] = [
        #'../network-examples/adj-format/DF.4.adj.txt 4 264', # 1056 hosts
        #'../network-examples/adj-format/DF.8.adj.txt 8 2064', # 16512 hosts
        #'../analysis-paths/DF.12.adj.txt 12 6936', # 83232 hosts
        #'../analysis-paths/JF-DF.4.adj.txt.1 4 264', # 1056 hosts
        #'../analysis-paths/JF-DF.8.adj.txt.1 8 2064', # 16512 hosts
        #'../analysis-paths/JF-DF.12.adj.txt.1 12 6936', # 83232 hosts

        
        #'../analysis-paths/FatTree.8.adj.txt 16 128', # 2048 hosts
        #'../analysis-paths/FatTree.16.adj.txt 32 512', # 16384 hosts
        #'../analysis-paths/FatTree.26.adj.txt 52 1352', # 70304 hosts
        #'../analysis-paths/JF-FT.8.adj.txt.1 7 320', # 2240 hosts (k'=13)
        #'../analysis-paths/JF-FT.16.adj.txt.1 13 1280', # 16640 hosts (k'=25)
        #'../analysis-paths/JF-FT.26.adj.txt.1 21 3380', # 16640 hosts (k'=41)

        #'../analysis-paths/HyperX3.15.adj.txt 5 216', # 1080 hosts
        #'../analysis-paths/HyperX3.30.adj.txt 10 1331', # 13310 hosts
        #'../analysis-paths/JF-HX3.15.adj.txt.1 5 216', # 1080 hosts
        #'../analysis-paths/JF-HX3.30.adj.txt.1 10 1331', # 13310 hosts
]
dia3['cwnd'] = [8]
dia3['queuesize'] = [8]


base = deepcopy(layered)
base['net'] = [#'baseline2x 16 128', 
               'baseline2x 32 512'
               #'baseline2x 52 1352'
              ]
base['cwnd'] = [15]
base['queuesize'] = [8]
base['strategy'] = ["SCATTER_PERMUTE"]
base['rho'] = [1]
base['n_layers'] = [-1]

parameters = [layered]

for pars in parameters:
    names = ['net', 'overcommit'] + list(sorted(k for k in pars if k not in ['net', 'overcommit']))
    for tup in product(*[pars[k] for k in names]):
        net, p, edge = tup[0].split(" ")
        name = net.split("/")[-1].replace(".", "_").replace("_txt", "")
        topo = name.split("_")[0]
        p = int(float(p) * tup[1])
        ks = ["name", "topo", "net", "p", "edge"] + names[1:]
        vs = [name, topo, net, p, edge] + list(tup[1:])
        name = "_".join(str(v) for k, v in zip(ks, vs) if k not in ("net", "topo", "overcommit"))
        vs = [name] + vs[1:] # updated name
        text = "\n".join("%s=%s" % (k, str(v)) for k, v in zip(ks, vs))
        with open(name + ".par", "w") as f:
            f.write(text)
            f.write("\n")


