# first build omnet, run ./configure, update Makefile.inc:
# turn on lto and turn off debug output
#CFLAGS_RELEASE = $(DEFINES)  -flto -O2 -DNDEBUG=1 -fPIC  -fno-stack-protector -DCOMPILETIME_LOGLEVEL=LOGLEVEL_OFF
# gcc-* version for lto
#AR = gcc-ar cr
#RANLIB = gcc-ranlib
# turn on lto again
#SHLIB_LD = g++ -shared -fPIC -flto -O3

cd ../../omnetpp-5.0/
make MODE=release clean
# compile in release mode with static libs
make MODE=release SHARED_LIBS=no V=1 -j12

cd ../inet/
make MODE=release clean
# as above. 
make MODE=release SHARED_LIBS=no V=1 -j12

cd ../low-diam-routing/omnet
# with SHARED_LIBS=no there is no opp_run, even though INET still builds (only) libINET.so.
# So we need  to make one. We link INET dynamically, but at compiletime, since we may not link
# libopp* statically and completly (that would create dulictes with libNET, which also has it 
# statically. We also can't just add the INET objects, since we need classes that are unused
# and would be optimized away (--whole-archive might help but causes duplicates again). 
# This works:
g++ -O3 -flto /[homefolder]/inet/src/libINET.so -o inet_run -loppmain -Wl,-u,_cmdenv_lib -loppcmdenv -loppenvir  -loppsim -loppnedxml -loppcommon -lxml2 -L"/[homefolder]/omnetpp-5.0/lib" -L/[OpenMP-path]/UES/RH6.7_PE15.12/easybuild/software/OpenMPI/1.10.2-GCC-5.3.0-2.26/lib -lmpi_cxx -lmpi -ldl -lstdc++
# libINET.so is referenced absolutely, otherwise the binary won't work after cd. The part in
# the end is for CSCS mpi. THe LTO here is quite useless, all the magic is already in libINET.so.

# The lto binary is about 10% faster than a build with the same options and no lto.
# The COMPILETIME_LOGLEVEL has a faily small impact, but NDEBUG and -O2 are really important.

# Run it as:
./inet_run -n ../../inet/src/:. -u Cmdenv
# the -n can't easily be compiled in, you still need to pass it. The -l switch must not be
# passed, it still works in theory but causes duplicate trouble again.

