#!/usr/bin/awk -f 
# Extract network topology from the nedfile. Might only work with the 
# autogenerated ones, but this is more correct than reading the graph file
# due to how undirected edges are formed form an directed file.
BEGIN {
    FS="[-<>A-Za-z;.+_ ]+"; # We only care about numbers
    OFS=", "
    print("CREATE TEMP TABLE topo(node INT, port INT, dest INT);")
    print("CREATE INDEX topomap ON topo(node, port);")
} 
/<--> Eth10G <-->/ {
    if (NF == 6){ t = "null"; } else { t = $4; } # Endpoint or Node
    print("INSERT INTO topo VALUES(" $2, p[$2]*1,  t ");"); 
    print("INSERT INTO topo VALUES("  t, p[ t]*1, $2 ");"); 
    p[$2]++; p[t]++;
}

END {
    # nontrivial SQL code to update the datapoints in the database.
    print(\
    "UPDATE datapoints SET dest = \
        (SELECT topo.dest FROM topo WHERE topo.node = datapoints.node AND topo.port = datapoints.port) \
     WHERE runid IN (SELECT runid FROM runs WHERE timestamp >= (SELECT datetime(max(timestamp),'-10 second') FROM runs)) \
        AND dest IS null; \
     ");
}
