//
// Copyright (C) 2004 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//
#ifndef __INET_TCPWORKLOADAPP_H
#define __INET_TCPWORKLOADAPP_H

#include "inet/common/INETDefs.h"
#include "inet/applications/tcpapp/TCPSessionApp.h"
#include "inet/applications/tcpapp/WorkloadConfigurator.h"

namespace inet {

/**
 * An application that opens one flow to a peer defined by the workload
 * and reports completion time.
 */
class INET_API TCPWorkloadApp : public TCPSessionApp
{
  protected:
    WorkloadConfigurator *workloadConfigurator;
    static simsignal_t completeSignal;

  public:
    TCPWorkloadApp();

  protected:
    virtual int numInitStages() const override { return NUM_INIT_STAGES; }
    virtual void initialize(int stage) override;
    virtual void connect() override;
    virtual void socketClosed(int connId, void *yourPtr) override;
};

} // namespace inet

#endif // ifndef __INET_TCPWORKLOADAPP_H

