
#include "inet/common/INETDefs.h"
#include "inet/common/queue/AlgorithmicDropperBase.h"
#include "inet/common/queue/IQueueAccess.h"
#include "inet/common/queue/IPassiveQueue.h"
#include "inet/common/queue/PriorityScheduler.h"

namespace inet {

class INET_API ECNTagger : public PriorityScheduler, public IQueueAccess
{
public:
protected:
    int numGates;
    std::vector<IQueueAccess*> queues;
    std::set<IQueueAccess*> queueSet;
    AlgorithmicDropperBase *dropperEcn;
    static simsignal_t tagPkSignal;
public:
protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual bool shouldTag(cPacket *packet);
    virtual void tagPacket(cPacket *packet);
    virtual int getLength() const;
    virtual int getByteLength() const;
};

}
