#ifndef __LETFLOWROUTINGTABLE_H
#define __LETFLOWROUTINGTABLE_H

#include <vector>
#include <tuple>

#include "inet/transportlayer/tcp_common/TCPSegment.h"
#include "inet/networklayer/ipv4/IPv4RoutingTable.h"

namespace inet {

class INET_API LetFlowRoutingTable: public IPv4RoutingTable
{
public:
    IPv4Route *findBestMatchingRoute(IPv4Datagram *datagram) const override;
    void initialize(int stage) override;

    typedef std::tuple<IPv4Address, IPv4Address, uint16_t, uint16_t> FourTuple;
    typedef std::tuple<IPv4Route*, simtime_t> FlowRoute;
    
private:
    mutable std::map<FourTuple, FlowRoute> flowtable;
    simtime_t flowletgap = 0; 

    static simsignal_t rerouteSignal;
};

}

#endif

