#ifndef __INET_MPTCPVIRTUALDATASENDQUEUE_H
#define __INET_MPTCPVIRTUALDATASENDQUEUE_H

#include "inet/transportlayer/mptcp/MPTCPSendQueue.h"

namespace inet {

class INET_API MPTCPVirtualDataSendQueue : public MPTCPSendQueue
{
  protected:
    uint32 begin;
    uint32 end;
    std::map<int, uint32> subflowBeginMap; // 1st sequence number stored
    std::map<int, uint32> subflowEndMap; // last sequence number stored +1
    MPTCPConnection *conn;

  public:
    MPTCPVirtualDataSendQueue() {ASSERT(false);};
    MPTCPVirtualDataSendQueue(MPTCPConnection *_conn);
    virtual ~MPTCPVirtualDataSendQueue();
    virtual void init(int subflowId, uint32 startSeq);
    virtual void enqueueAppData(cPacket *msg);
    virtual uint32 getBufferStartSeq(int subflowId);
    virtual uint32 getBufferEndSeq(int subflowId);
    virtual TCPSegment *createSegmentWithBytes(int subflowId, uint32 fromSeq, ulong maxNumBytes);
    virtual void discardUpTo(int subflowId, uint32 seqNum);
    virtual void reserveUpTo(int subflowId, uint32 seqNum);

    /**
     * Returns a string with the region stored.
     */
    virtual std::string info(int subflowId);

};

}

#endif
