//
// Copyright (C) 2013 Opensim Ltd.
// Author: Levente Meszaros
// Author: Marcel Schneider (TCP version)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//

#ifndef __INET_TCPMULTIPLEXER_H
#define __INET_TCPMULTIPLEXER_H

#include "inet/common/INETDefs.h"
#include <map>

namespace inet {
namespace tcp {

/**
 * This class provides TCP control message multiplexing based on the connection ID.
 */
class INET_API TCPMultiplexer : public cSimpleModule
{
  public:
    TCPMultiplexer() {}
    virtual ~TCPMultiplexer() {}

  protected:
    virtual void handleMessage(cMessage *message) override;
    int getConnId(cMessage *message);
    
    std::map<int,int> connIdToGate;
};

} // namespace tcp
} // namespace inet

#endif // ifndef __INET_TCPMULTIPLEXER_H

