//
// Copyright (C) 2004 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//

#ifndef __INET_DCTCP_H
#define __INET_DCTCP_H

#include "inet/common/INETDefs.h"
#include "inet/transportlayer/tcp/flavours/TCPTahoeRenoFamily.h"
#include "inet/transportlayer/tcp/flavours/TCPReno.h"

#define DCTCP_G (0.03)

namespace inet {
using namespace tcp;

/**
 * Implements DCTCP.
 */
class INET_API DCTCP : public TCPReno
{
  protected:
    double dctcp_alpha;
    uint32 acked_bytes_ecn;
    uint32 acked_bytes_total;
    virtual void rttMeasurementComplete(simtime_t tSent, simtime_t tAcked) override;
  public:
    /** Ctor */
    DCTCP();
    virtual void receivedDataAck(uint32 firstSeqAcked) override;
    virtual void receiveSeqChanged() override;
};

}

#endif
