//
// Copyright (C) 2004 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//

#ifndef __INET_FLOWLETDCTCP_H
#define __INET_FLOWLETDCTCP_H

#include "inet/transportlayer/tcp/flavours/DCTCP.h"

namespace inet {
using namespace tcp;

/**
 * DCTCP with layered flowlet switching.
 */
class INET_API FlowletDCTCP : public DCTCP
{
  public:
    /** Ctor */
    FlowletDCTCP();
    virtual void receivedDataAck(uint32 firstSeqAcked) override;
    virtual void processRexmitTimer(TCPEventCode& event) override;
    /** 
     * Called to inform congestion control that a packet was lost.
     * Should immediatly trigger the rexmit timer.
     */
    virtual void packetLost();

    /**
     * Initiates a layer change.
     */
    virtual void switchLayer();
};

}

#endif
