#!/usr/bin/env python3
from itertools import product
from copy import deepcopy

layered = {
    'net': [
        #'Star_0.txt 60 1',
        #'../analysis-paths/Complete.32.adj.txt 32 32', # 1024 hosts

        #'../network-examples/adj-format/DF.4.adj.txt 4 264', # 1056 hosts
        #'../network-examples/adj-format/DF.8.adj.txt 8 2064', # 16512 hosts
        #'../analysis-paths/JF-DF.4.adj.txt.1 4 264', # 1056 hosts
        #'../analysis-paths/JF-DF.8.adj.txt.1 8 2064', # 16512 hosts
        
        #'../network-examples/adj-format/MMS.11.adj.txt 5 98', # 490 hosts
        #'../network-examples/adj-format/MMS.29.adj.txt 14 722', # 10108 hosts
        #'../network-examples/adj-format/MMS.55.adj.txt 28 2738', # 76664 hosts
        #'../analysis-paths/JF-MMS.17.adj.txt.1 8 242', # 1936 hosts
        #'../analysis-paths/JF-MMS.29.adj.txt.1 14 722', # 10108 hosts
        #'../analysis-paths/JF-MMS.55.adj.txt.1 28 2738', # 76664 hosts
        
        #'../analysis-paths/FatTree.9.adj.txt 9 162', # 1458 hosts
        '../analysis-paths/FatTree.18.adj.txt 18 648', # 11664 hosts
        #'../analysis-paths/JF-FT.9.adj.txt.1 4 405', # 1620 hosts
        '../analysis-paths/JF-FT.18.adj.txt.1 7 1620', # 11340 hosts

        #'../analysis-paths/HyperX2.22.adj.txt 11 144', # 1584 hosts
        #'../analysis-paths/HyperX2.42.adj.txt 21 484', # 10164 hosts
        #'../analysis-paths/JF-HX2.22.adj.txt.1 11 144', # 1584 hosts
        #'../analysis-paths/JF-HX2.42.adj.txt.1 21 484', # 10164 hosts

        #'../analysis-paths/HyperX3.15.adj.txt 5 216', # 1080 hosts
        #'../analysis-paths/HyperX3.30.adj.txt 10 1331', # 13310 hosts
        #'../analysis-paths/JF-HX3.15.adj.txt.1 5 216', # 1080 hosts
        #'../analysis-paths/JF-HX3.30.adj.txt.1 10 1331', # 13310 hosts


    ],
    'overcommit':   [1.0],
    "activefraction": [1.0],
    'workload': ["stencil"],
    'mapping': ["random"],
    "tcptype": ["FlowletDCTCP"],
    "ecmp_limit": [1],
    "encode": ['layered'],
    "layer": ["shortest_1,sparse_0.6_3", 
              "shortest_4"],
    "router": ["ECMPRouter"],
    "flowsize": ["pfabric"],
    "lambda": [200],
}

ecmp = deepcopy(layered)
ecmp['encode'] = ['ecmp']
ecmp['layer']  = ['shortest']
ecmp['ecmp_limit'] = [8]
ecmp['tcptype'] = ['DCTCP']

letflow = deepcopy(ecmp)
letflow['router'] = ['LetFlowRouter']
letflow['flowletgap'] = ['50us']

parameters = [ecmp, letflow, layered]

for pars in parameters:
    names = ['net', 'overcommit'] + list(sorted(k for k in pars if k not in ['net', 'overcommit']))
    for tup in product(*[pars[k] for k in names]):
        net, p, edge = tup[0].split(" ")
        name = net.split("/")[-1].replace(".", "_").replace("_txt", "")
        topo = name.split("_")[0]
        p = int(float(p) * tup[1])
        ks = ["name", "topo", "net", "p", "edge"] + names[1:]
        vs = [name, topo, net, p, edge] + list(tup[1:])
        name = "_".join(str(v) for k, v in zip(ks, vs) if k not in ("net", "topo", "overcommit"))
        vs = [name] + vs[1:] # updated name
        text = "\n".join("%s=%s" % (k, str(v)) for k, v in zip(ks, vs))
        with open(name + ".par", "w") as f:
            f.write(text)
            f.write("\n")


